%This file reproduce the bootstrap-based exercise in tables 4-5 of Main Text as well of Table 11 of Supplement of Zanetti Chini (2018) 
clear
clc
%
%% STEP 1: IMPORT DATA 
% SElect the data of interest and its relative transformation
importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/Data_q');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/mUSIIP.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/mUSUN.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/lynx.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/ssn_yearly.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/SmoothSSN.xls')
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/Entry.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/Exit.xls');
%
% Selecting and filtering
y = 100*(log(UNRATE) - lag(log(UNRATE),4)); y=y(9:end);                  % US IIP in monthly growth rate
%y = 100*(log(mUN) - lag(log(mUN),12)); y=y(13:end);                   % US UNEMPLOYEMNT RATE in levels                                                                      
%y = log10(LYNX);                                                         % Canadian Lynx
%y = sqrt(SSN(1:end-3));                                                  % Yearly SSN (use square root transformation)
%y = log(MSmoothSSN(1213:end));                                           % Monthly Smoothed SSN (log tansformation)
%y = 100*(log(Entry) - lag(log(Entry),4))/4; y=y(5:end);
%y = 100*(log(Exit) - lag(log(Exit),4))/4; y=y(5:end);
%y = y - lag(y,1) ;  % (eventually in change rate)
%Some general parameters
T = length(y);
c = mean(y);
% 10,000 bootstrap replications
B = 10000;
% Initial place for mu-star
muStar = zeros(B,1);
%Prepare for AR 
O = ones(T,1);
x0 = [O lag(y,1) lag(y,2)  ];
%% STEP 2: ESTIMATE THE MODEL
%Estimate AR
O = ones(length(y),1);
y_ar=ols(y, x0);
yhat_ar = y_ar.yhat;
lambda_ar = y_ar.beta;
[LogLik_ar] = LLF(T,y_ar.sige,y_ar.bstd);
%
% Estimate a MRSTAR/GSTAR
O = ones(length(y),1);
X = [O, lag(y,1) lag(y,2) lag(y,3) lag(y,4) ]; % AR(6) for IP, AR(4) for UN, AR(5) for YSSN, logSSN, sqrt MSSN, AR(6) for DLMSSN, AR(7) for LYNX
W = [];         % Matrix of exogenous covariates
q = lag(y,1);   % 5 for IP, 2 for UN, 1 for SSN, 4 for LYNX
T = length(y);
nX = size(X,2); % # of covariates
nW = 0;         % # of Exogenous variables
M = [];         % Max # of Regimes (if empty the function compute it automatically)
rob = 1;        % HAC-robust test ?
flag = 1;       % the q is part of the covariates ?
sig = 0.01;      % nominal size (0.01 for IP and UN, 0.5 for SPR, 0.05 for LYNX)
m=1; 
%initial values
gamma_0=0;
gamma1_0=0;
gamma2_0=0;
%p = mbic(y, O, X, 12);
% Call the function for MR-STAR model
[yhat_mrstar,ehat,alpha,beta,lambda,gamma,c,se,G,fX,pval_lin] = mrstar(y,X,W,q,T,nX,nW,M,rob,flag,sig);
%
% Call the function for GSTAR model
[alpha_gstar,beta_gstar,lambda_gstar,gamma1,gamma2,c_gstar,fX_gstar,yhat_gstar,ehat_gstar,G_gstar,sigma_gstar,se_gstar]=parestGSTARlm(y,X,W,q,T,nX,nW,m,gamma1_0,gamma2_0,c(1));
%
T_tilde = length(yhat_ar);
%
%% STEP 3: STATIONARY AR BOOTSTRAP
%
%yStar = zeros(T_tilde,1);
%for i=1:B
% Initialize to one of the original values
%yStar(1) = yhat_gstar(ceil(T_tilde*rand));
% Indices for errors
%u = ceil((T_tilde-1)*rand(T_tilde,1));
% Recursion to simulate AR
%   for t=2:T_tilde
%       yStar(t) = yStar(t-1) + ehat_gstar(u(t));
%   end
%end

%% STATIONARY BLOCK BOOTSTRAP
% Average block size
m = 10;
yStar = zeros(T_tilde,1);
% Loop over B bootstraps
yRepl = [yhat_ar;yhat_ar]; % Put yhat_ar, yhat_mrstar or yhat_gstar
u = zeros(T_tilde,1);
for b=1:B
u(1) = ceil(T_tilde*rand);
    for t=2:T_tilde
        if rand<1/m
            u(t) = ceil(T_tilde*rand);
        else
            u(t) = u(t-1) + 1;
        end
    end
%y-star sample simulation
yStar = yRepl(u);
% Mean of y-star
muStar(b) = mean(yStar);
end
%
F = yStar;
mu = mean(F,1);
sigma = var(F);
T_hat=length(F);
Pdens=zeros(T,1);
n = sqrt(T_hat);
%
%Average the Predictive densities (or Fan Chart upper-lower percentiles).
%
for i=1:T_hat
Pdens(i,:) = (1/size(F,2))*(sum(pdf('norm',F(i,:),mu,sigma),2));
end
y=Pdens;
%
%
%   Then, select bandwidth for the Rolling Window
%
alpha = 0.01;                    % 0.01 for IP and UN, 0.05 for others.
h=1;                             %h-step ahead estimation
bw = 100;                        % rolling window
oos_reg0=[]; oos_reg1=[]; yoos=[]; predreg=[];
% without out of sample
for i=1:T_tilde-(bw+h)+1
    [B0 Bint0 R0] = regress(y(i:i+bw-1,:),x0(i:i+bw-1,:));  
    %[B1 Bint1 R1] = regress(data(i:i+bw-1,:),x1(i:i+bw-1,:));
    R1= ehat_gstar(i:i+bw-1,:);
    
    oos_reg0(i,:)=  [ x0(bw+i,:)];
    oos_reg1(i,:)=  [ yhat_ar(bw+i,:)]; % Put yhat_ar, yhat_mrstar or yhat_gstar
    yoos(i,:) = y(bw+i,:);
end
%
% Finally, use Point forecast statsitics...
%
%B0=[B(1); zeros(p-1,1)];
%predreg= ((ones(size(B(2:end))) + B(2:end)).^h-1).*B0 + B(2:end).^h)*oos_reg(:,2:end);
predreg= oos_reg0*(B0.^h);
%[ME]=meanerror(yoos,predreg);
[ME]=meanerror(yoos,oos_reg1);
%[sMAPE] = medianerror(yoos, predreg);
[sMAPE] = medianerror(yoos, oos_reg1);
%[rMAE] = medianrelerror(yoos,predreg, predreg);
[rMAE] = medianrelerror(yoos,predreg, oos_reg1)
%[RMSFE] = mse(yoos,predreg);
[RMSFE] = mse(yoos,oos_reg1);

%....and Density forecast stastitics...
[logS] = logScore(oos_reg1, T);
[qsr] = qscore(R1,oos_reg1);
[QuantileS] = QuantileS(oos_reg1, alpha);
[CRPS] = CRPS(oos_reg1, c(1));
%
% AND PLOT THE RESTULTS
disp('') , disp('FORECAST EVALUATION RESULTS' ) , disp('')
disp('-----------------------------------------------') 
disp('') , disp( sprintf('Nominal Size: %1.2f' , alpha )) , disp('')
disp('') , disp( sprintf('h-step ahead: %1.0f' , h )) , disp('')
disp('') , disp( sprintf('Rolling Window length: %1.0f' , bw )) , disp('')
disp('-----------------------------------------------') 
disp('') , disp('POINT Forecasts' ) , disp('')
disp('-----------------------------------------------') 
disp('') , disp( sprintf('Mean Forecast Error: %1.4f' , ME )) , disp('')
disp('') , disp( sprintf('Symmetric Mean Percentage Error: %1.4f' , sMAPE )) , disp('')
disp('') , disp( sprintf('Relative Mean Absolute Error: %1.4f' , rMAE )) , disp('')
disp('') , disp( sprintf('Root Mean Forecast Error: %1.4f' , RMSFE )) , disp('')
%disp('') , disp( sprintf('Nominal Risk level: %1.2f' , alpha) ) , disp('')
disp('-----------------------------------------------') 
disp('') , disp('DENSITY Forecasts' ) , disp('')
disp('-----------------------------------------------') 
disp('') , disp( sprintf('Logarhithmic Score: %1.4f' , logS ) ) , disp('')
disp('') , disp( sprintf('Quadratic Score: %1.4f' , qsr ) ) , disp('')
disp('') , disp( sprintf('CRPS Score: %1.4f' , CRPS ) ) , disp('')
disp('') , disp( sprintf('Quantile Score: %1.4f' , QuantileS ) ) , disp('')
disp('-----------------------------------------------') 
