
function [U, thetawGgamma1gamma1, thetawGgamma1gamma2, thetawGgamma1c, thetawGgamma2gamma1, thetawGgamma2gamma2,...
    thetawGgamma2c, thetawGcgamma1, thetawGcgamma2, thetawGcc, ddloglik, E, H] = Hessian(theta, w1, w2, w, thetawGgamma1,...
    thetawGgamma2, thetawGc, Ggamma1gamma1, Ggamma1gamma2, Ggamma1c, k, u, Ggamma2gamma1, Ggamma2gamma2, Ggamma2c, Gcgamma1, Gcgamma2, Gcc, sigma2_hat)
%This function compute the Hessian for the Two-Step test

%Define the elements of the block matrix 
thetawGgamma1gamma1 = [theta(1,:).*w1.*Ggamma1gamma1; theta(2,:).*w2.*Ggamma1gamma1];
thetawGgamma1gamma2 = [theta(1,:).*w1.*Ggamma1gamma2; theta(2,:).*w2.*Ggamma1gamma2];
thetawGgamma1c = [theta(1,:).*w1.*Ggamma1c; theta(2,:).*w2.*Ggamma1c];
thetawGgamma2gamma1 = [theta(1,:).*w1.*Ggamma2gamma1; theta(2,:).*w2.*Ggamma2gamma1];
thetawGgamma2gamma2 = [theta(1,:).*w1.*Ggamma2gamma2; theta(2,:).*w2.*Ggamma2gamma2];
thetawGgamma2c = [theta(1,:).*w1.*Ggamma2c; theta(2,:).*w2.*Ggamma2c];
thetawGcgamma1 = [theta(1,:).*w1.*Gcgamma1; theta(2,:).*w2.*Gcgamma1];
thetawGcgamma2 = [theta(1,:).*w1.*Gcgamma2; theta(2,:).*w2.*Gcgamma2];
thetawGcc = [theta(1,:).*w1.*Gcc; theta(2,:).*w2.*Gcc];

%We need to holding with a zero vector
zero = zeros(1,length(w));
%And the vector of estimated residual to multiply for each block-element
one= ones(length(theta),1);
U = kron(u, one);

%Define the Hessian
ddloglik = [sum(zero), sum(zero), sum(zero), sum(zero), sum(zero);
            sum(zero), sum(zero), sum(thetawGgamma1), sum(thetawGgamma2), sum(thetawGc);
            sum(zero), sum(thetawGgamma1), sum(thetawGgamma1gamma1), sum(thetawGgamma1gamma2), sum(thetawGgamma1c)  ;
            sum(zero), sum(thetawGgamma2), sum(thetawGgamma2gamma1), sum(thetawGgamma2gamma2), sum(thetawGgamma2c)  ;
            sum(zero), sum(thetawGc), sum(thetawGcgamma1), sum(thetawGcgamma2), sum(thetawGcc)];
        
        %But we will use the matrix E, in which the previously computed
        %matrix is multiplied in each block element by U
        E=[U'*zero', U'*zero', U'*zero', U'*zero', U'*zero';
           U'*zero', U'*zero', U'*thetawGgamma1, U'*thetawGgamma2, U'*thetawGc;
           U'*zero', U'*thetawGgamma1, U'*thetawGgamma1gamma1, U'*thetawGgamma1gamma2, U'*thetawGgamma1c;
           U'*zero', U'*thetawGgamma2, U'*thetawGgamma2gamma1, U'*thetawGgamma2gamma2, U'*thetawGgamma2c;
           U'*zero', U'*thetawGc, U'*thetawGcgamma1, U'*thetawGcgamma2, U'*thetawGcc];
       
% Finally we get the Hessian          
H = -sigma2_hat^(-1).*(k'*k - E);

end
