function [sigma2_hat, w1, w2, w, wG, thetawGgamma1, thetawGgamma2, thetawGc, k, q] = Score(y_gstar, theta, G, Ggamma1, Ggamma2, Gc, T,u)
%This file compute the Score function of a GSTR model

sigma2_hat = (1/T)*sum((u.^2));  %compute the variance of the residuals 

%Step 0: change the notation: w will be a (pxT)x1 vector
W=[lag(y_gstar,1),lag(y_gstar,2)];


w1=W(:,1); w2=W(:,2); w=[w1;w2];


%Step 1: Define the elements of Score matrix 
wG = [w1.*G; w2.*G];
thetawGgamma1 = [theta(1,:).*w1.*Ggamma1; theta(2,:).*w2.*Ggamma1];
thetawGgamma2 = [theta(1,:).*w1.*Ggamma2; theta(2,:).*w2.*Ggamma2];
thetawGc = [theta(1,:).*w1.*Gc; theta(1,:).*w2.*Gc];


%Step 2: Build up the matrix
k = [w, wG, thetawGgamma1, thetawGgamma2, thetawGc];

%Step 3: define the aveScore q as the normalized sum of each sub-vector of k.

q = (-(sigma2_hat*T)^(-1))*(k'*repmat(u,2,1));






end
