function [LM1, LM2, LM3, pval_LM1, pval_LM2, pval_LM3] = dtest_paramconst(ehat, X, T, G_stuk, Ggamma1, Ggamma2, Gc)
% This function perform the LM test for the null of PARAMETER CONSTANCY AND
% computes the p-values for all thee possible parametrizations.

%Define the matrix of regressors
U = ehat;
p=size(X,2);
O=ones(1,p);
Z=X';
ZG=Z'.*kron(O,G_stuk);
ZGgamma1=Z'.*kron(O,Ggamma1);
ZGgamma2=Z'.*kron(O,Ggamma2);
ZGc=Z'.*kron(O,Gc);
k = size(X,2);  
l = size(X,2);
t = (1:T)';
ZT = kron(O,t);
z=[Z' ZG ZGgamma1, ZGgamma2, ZGc];
%Matrix V for the null of constancy with GLSTAR time variation
V2 = [ ZT.*Z'  ZT.*ZG];
%Matrix V for the null of constancy with GESTAR time variation
V1 = [ ZT.*Z' (ZT.^2).*Z'  ZT.*ZG (ZT.^2).*ZG];
%Matrix V for the null of constancy with UNKNOWN time variation
V3 = [];
%Matrix V for the ALTERNATIVE HP
V = [ ZT.*Z' (ZT.^2).*Z' (ZT.^3).*Z'  ZT.*ZG (ZT.^2).*ZG (ZT.^3).*ZG];
% Define the Covariate matrix
z01 = [V1 z]; % Matrix of covariates UNDER THE NULL of MONOTHONIC ASYMMETRY. 
z02 = [V2 z ]; % Matrix of covariates UNDER THE NULL of NON-MONOTHONIC ASYMMETRY. 
z03 = [V3 z]; % Matrix of covariates UNDER THE NULL of NO ADDITITIVE ASYMMETRY.                      
z1 = [V z]; % Matrix of covariates UNDER THE ALTERNATIVE. 

%Regress and store the etimates and residuals under H0 - 
%NOTE: WE USE THE HETERO-ROBUST VERSION of
%the test while regressing U=[hat_u_tvgstar(t)] on z.
params01_ols = ols(U, z01);                    params02_ols = ols(U, z02);                   params03_ols = ols(U, z03);
params01_est = [params01_ols(1:end).beta];     params02_est = [params02_ols(1:end).beta];    params03_est = [params03_ols(1:end).beta];
RES01 = [params01_ols(1:end).resid];           RES02 = [params02_ols(1:end).resid];          RES03 = [params03_ols(1:end).resid];
SE01 = [params01_ols(1:end).bstd];             SE02 = [params02_ols(1:end).bstd];            SE03 = [params03_ols(1:end).bstd];
SSR01 = sum(RES01.^2);                         SSR02 = sum(RES02.^2);                        SSR03 = sum(RES03.^2);
sigma201 = (1/T)*SSR01;                        sigma202 = (1/T)*SSR02;                       sigma203 = (1/T)*SSR03;

%Regress and store the etimates and residuals under H1
tvparams13_ols = ols(U, z1);
tvparams13_est = [tvparams13_ols(1:end).beta];
RES13 = [tvparams13_ols(1:end).resid];
SE113 = [tvparams13_ols(1:end).bstd];
SSR1 = sum(RES13.^2);
sigma21 = (1/T)*SSR1;               

%   Chi2 statistic and p-values
%LM1 = (SSR01-SSR1)/sigma21; pval_LM1 = 1-cdf('chi2', LM1 , 3*(k+l));
%LM2 = (SSR02-SSR1)/sigma21; pval_LM2 = 1-cdf('chi2', LM2 , 3*(k+l));
%LM3 = (SSR03-SSR1)/sigma21; pval_LM3 = 1-cdf('chi2', LM3 , 3*(k+l));

%   F-statistic and p-value 
%n=length(z);
LM1 = ((SSR01-SSR1)/(3*(k+l))/(SSR1/(T-4*(k+l)-p))); pval_LM1 = 1-cdf('f', LM1, 3*(k+l), T-4*(k+l)-p);
LM2 = ((SSR02-SSR1)/(3*(k+l))/(SSR1/(T-4*(k+l)-p))); pval_LM2 = 1-cdf('f', LM2, 3*(k+l), T-4*(k+l)-p);
LM3 = ((SSR03-SSR1)/(3*(k+l))/(SSR1/(T-4*(k+l)-p))); pval_LM3 = 1-cdf('f', LM3, 3*(k+l), T-4*(k+l)-p);
end