function [LM, pval] = dtest_sc(ehat, q, X, G_stuk, Ggamma1, Ggamma2, Gc)
%This function provides the LM test and p-value for test for no serial
%correlation

%Define the vector v_hat
v_hat = zeros(length(ehat),q);   %preallocate the vector v_hat
for j=1:q;
    v_hat(:,j) = lag(ehat,j) ;   %define v=[u_gstar(t-1),...,u_gstar(t-q)]
end

%Define the vectors 
Z = X';
p = size(X,2);
U = ehat;
O=ones(1,p);
ZG=Z'.*kron(O,G_stuk);
z = [v_hat, Z', ZG, Ggamma1, Ggamma2, Gc];
T=length(Z);
%Regress and store the etimates and residuals of the model generated UNDER 
%THE NULL HYPOTHESIS OF NO ERROR AUTOCORRELATION
params_ols = ols(U, [Z' ZG]);
params_est = [params_ols(1:end).beta];
RES = [params_ols(1:end).resid];
SE = [params_ols(1:end).bstd];
SSR=sum(RES.^2);
sigma2 = (1/T)*SSR;
%Regress and store the etimates and residuals under H1 (The estimates under
%H0 has been done previously)
params1_ols = ols(U, z);
params1_est = [params1_ols(1:end).beta];
RES1 = [params1_ols(1:end).resid];
SE1 = [params1_ols(1:end).bstd];
SSR1=sum(RES1.^2);
sigma21 = (1/T)*SSR1;

%F-statistic
n = size([Z', ZG, Ggamma1, Ggamma2, Gc],2);
%LM = (SSR-SSR1)/(sigma21);
LM = ((SSR-SSR1)/(q))/(SSR1/(T-q-n));

%Compute the p-value according to the so found statistics
%pval = 1-cdf('chi2', LM , q);
pval = 1-cdf('f', LM, q, T-q-n);
end
