function [GL] = h_SLN(gamma1, gamma2, theta, s, c)
%This function performs the Generalized Logistic function by Sollis, Laybourne and Newbold (2002)
h1 = (1 + exp(-gamma1*(s - c ))).^(-theta) ; 
h2 = (1 + exp(-gamma2*(s - c ))).^(-theta) ; 
GL = ((s-c)<0).*(h1) + ((s-c)>=0).*(h2);
end