t% This file replicates the empirical application of GSTAR model for real
% data
clear
clc

%% STEP 0: IMPORT AND TRANSFORM DATA 
% Import data
importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/mUSIIP.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/mUSUN.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/lynx.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/ssn_yearly.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/SmoothSSN.xls')
%
% Select data
y = 100*(log(mIIP) - lag(log(mIIP),12))/12; y=y(13:end);                 % US IIP in monthly growth rate
%y = 100*(log(mUN) - lag(log(mUN),12))/12; y=y(13:end);                   % US UNEMPLOYEMNT RATE in levels                                                                      
%y = log10(LYNX);                                                         % Canadian Lynx
%y = sqrt(SSN(1:end-3));                                                   % Yearly SSN (use square root transformation)
%y = log(MSmoothSSN(1213:end));                                           % Monthly Smoothed SSN (log tansformation)
%y = y - lag(y,1) ;                                                       %(eventually in change rate)
%T = length(y);
c = mean(y);
%
%Select the pre-averaging threshold t and h
%t = 150;
%% FORECAST EVALUATION

O = ones(length(y),1);
X = [O, lag(y,1) lag(y,2) lag(y,3) lag(y,4)  lag(y,5)  ]; % AR(6) for IP, AR(4) for UN, AR(5) for YSSN, logSSN, sqrt MSSN, AR(6) for DLMSSN, AR(7) for LYNX
W = [];         % Matrix of exogenous covariates
q = lag(y,1);   % 5 for IP, 2 for UN, 1 for SSN, 4 for LYNX
T = length(y);
nX = size(X,2); % # of covariates
nW = 0;         % # of Exogenous variables
M = [];         % Max # of Regimes (if empty the function compute it automatically)
rob = 1;        % HAC-robust test ?
flag = 1;       % the q is part of the covariates ?
sig = 0.05;      % nominal size (0.01 for IP and UN, 0.5 for SPR, 0.05 for LYNX)
m=1; 
%initial values
gamma_0=0;
gamma1_0=0;
gamma2_0=0;

% Call the function for MR-STAR model
[yhat,ehat_mrstar,alpha,beta,lambda,gamma,c,se,G,fX,pval_lin] = mrstar(y,X,W,q,T,nX,nW,M,rob,flag,sig);

% Call the function for GSTAR model
[alpha_gstar,beta_gstar,lambda_gstar,gamma1,gamma2,c_gstar,fX_gstar,yhat_gstar,ehat_gstar,G_gstar,sigma_gstar,se_gstar]=parestGSTARlm(y,X,W,q,T,nX,nW,m,gamma1_0,gamma2_0,c(1));

[t n] = size(yhat);
m = 100;
R = 100;
P = t-R;

f_in_roll1=[];   f_oos_roll1=[];
f_in_roll2=[];   f_oos_roll2=[];

f_in_roll1=[];   f_oos_roll1=[];
f_in_roll2=[];   f_oos_roll2=[];

j = 1;
while j <= P
    p = mbic(y(j:j+R-1,:),[], X(j:j+R-1,:),  12);
    rgr = [];
    start = j + p;
    
    for i = 1:p
        rgr = [rgr X(start-i:R+j-i,:)];
    end
    
    [beta betaint r] = regress(y(start-1:R+j-1), rgr);
    predrgr = [X(R+j,:) rgr(end,1:end-size(X,2))];
    
    f_in_roll1    = [f_in_roll1;  r(end,:)^2 ]; 
    f_in_roll2    = [f_in_roll2;  y(j+R-1,:).^2 ];
    f_oos_roll1   = [f_oos_roll1 ;  predrgr*beta];
    f_oos_roll2   = [f_oos_roll2 ; 0];
    
    j = j+1;
end

RMSFE = mean(sqrt(r.^2))

DeltaL_oos = LossDiff_gr(f_oos_roll1, f_oos_roll2, y(1+R:end,:));
DeltaL_in  = f_in_roll1 - f_in_roll2; 

qn = floor(size(DeltaL_oos,1)^(1/4));
sigma = sqrt(nw(DeltaL_oos,qn));

DMW  = sqrt(size(DeltaL_oos,1))*mean(DeltaL_oos)/sigma;
GWp = 1-cdf('chi2', DMW^2,1);

if (GWp>0.05)
    GWp = 0;
else
    GWp = 1;
end

results = abc(DeltaL_oos, DeltaL_in, m, qn);
stats = results.stats;
rej = results.rej;

cv = results.cb;

x1 = [1 1 length(results.A) length(results.A)];
y1 = [cv(1,1) cv(1,2) cv(1,2) cv(1,1)];

table = [ DMW  GWp; stats(1,1) rej(1,1); stats(1,2) rej(1,2); stats(1,3) rej(1,3)];

