function [thetadd, etaadd, sadd, cadd, eta_tadd, hadd, muadd, Gadd]=sim_Gadd_glstar1(phi0, phi, theta0, theta1add, theta2add, gamma1add, gamma2add, w, T)
%This function build the G function of GLSTAR1 model

%Definitions
thetadd=[theta1add; theta2add];


%Definitions for Nonlinear part
etaadd = phi0 + phi'*w + theta0 + thetadd'*w ;
sadd = lag(etaadd,1) ;
cadd = (1/T)*sum(etaadd) ;
eta_tadd = (sadd - repmat(cadd,length(sadd),1)) ;
                                

%Define the Stukel function (fromula 2-3)
h11 = (gamma1add^(-1))*(exp(gamma1add.*abs(etaadd)) - 1) ; 
h12 = etaadd ;
h13 = (-gamma1add^(-1))*log(1 - gamma1add.*abs(etaadd)) ; 

h21 = (-gamma2add^(-1))*(exp(gamma2add.*abs(etaadd)) - 1) ;
h22 = etaadd ;
h23 = (gamma2add^(-1))*log(1 - gamma2add.*abs(etaadd)) ; 
         
if gamma1add > 0
    h1 = h11;
elseif gamma1add == 0
    h1 = h12;
else h1 = h13;
end

if gamma2add > 0
   h2 = h21;
elseif gamma2add == 0
    h2 = h22 ;
else h2 = h23;
end

%Define: h_gamma, mu_gamma and G
hadd = ((eta_tadd) <=0).*(h2') + ((eta_tadd) >=0).*(h1');
muadd = exp(hadd)./(1 + exp(hadd));
Gadd = (1 + exp(-hadd)).^(-1);

end