function [y_gstar, y_addgstar, u_addgstar, p, bar_z, Z] = sim_addGSTAR(y, phi0, phi1, phi2, theta0, theta1, theta2, pi0, pi1, pi2, T, G1, G2, eps)
%Simulate the GLSTAR process with AN ADDITIVE ASYMMETRIC G FUNCTION which
%following a GLSTAR model

%Define the model without ADDITIVE G

p = T-length(y);
bar_z = [lag(y,1), lag(y,2)]';
phi = [phi0, phi1, phi2]';
theta = [theta0, theta1, theta2]';
pi = [pi0, pi1, pi2]';
Z = [ones(1,length(bar_z))', bar_z']';

%Define the model with ADDITIVE G
eps1 = eps(p+1:end)';
y_gstar = phi'*Z + theta'*Z.*G1' + eps1;
y_addgstar = phi'*Z + theta'*Z.*G1' + pi'*Z.*G2' + eps1 ;
u_addgstar = y_addgstar - phi'*Z - theta'*Z.*G1'- phi'*Z.*G2';
end