function [y_tv1gstar,y_tv2gstar,y_tv3gstar,u_tv1gstar,u_tv2gstar,u_tv3gstar,Z] = tv_GSTAR(y,G,phit_1,phit_2,phit_3,thetat_1,thetat_2,thetat_3,eps1,T,p)

%Simulate the GSTAR process with TV parameters following a GLSTAR time
%variation (modify opportunaly the thetat_i vector for other types of time
%variations)
bar_z = [lag(y,1), lag(y,2)]';
Z = [ones(1,length(bar_z))', bar_z']';
for i=1:T-p
y_tv1gstar = phit_1'*Z*(1-G) + thetat_1'*Z*G + eps1 ;
y_tv2gstar = phit_2'*Z*(1-G) + thetat_2'*Z*G + eps1 ;
y_tv3gstar = phit_3'*Z*(1-G) + thetat_3'*Z*G + eps1 ;
u_tv1gstar = y_tv1gstar - phit_1'*Z*(1-G) - thetat_1'*Z*G;
u_tv2gstar = y_tv2gstar - phit_2'*Z*(1-G) - thetat_2'*Z*G;
u_tv3gstar = y_tv3gstar - phit_3'*Z*(1-G) - thetat_3'*Z*G;
end
end